#! /usr/bin/perl -w

if (scalar @ARGV != 1 && scalar @ARGV != 5) {
    die "Wrong number of arguments";
}

$bbox = "$ARGV[1] $ARGV[2] $ARGV[3] $ARGV[4]" if scalar @ARGV == 5;

open(IN, $ARGV[0]) or die "Cannot open input file $ARGV[0]";
binmode IN;

$BUFLEN = 256;

$n = read(IN, $buf, $BUFLEN);
if (!defined $n || $n < 2 || ! ($buf =~ /^%!/)) {
    die "File $ARGV[0] is not PostScript";
}

sub getline {
    while (!($buf =~ /[\r\n]./)) {
	my $n = read(IN, $buf, $BUFLEN, length $buf);
	die "I/O error reading file $ARGV[0]" if !defined $n;
	if ($n == 0) {
	    my $retval = length $buf;
	    ($line = $buf) =~ s/\015\012?|\012//;   # Can't use \r or \n here
	    $buf = '';
	    return $retval;
	}
    }
    ($line, $buf) = split /\015\012?|\012/, $buf, 2;
    return 1;
}

print "%!PS-Adobe-3.0\n";

$passthrough = 0;

while (getline() && ($line =~ /^%\S/)) {
    if ($line =~ /^%%([a-zA-Z]+:?)/) {
	if ($1 eq 'DocumentNeededFonts:' || $1 eq 'DocumentNeededResources:') {
	    print "$line\n";
	    $passthrough = 1;
	}
	elsif ($1 eq 'BoundingBox:' && ! (defined $bbox)) {
	    ($bbox = $line) =~ s/^%%BoundingBox: *//;
	}
	elsif ($1 eq 'EndComments') {
	    last;
	}
	else {
	    $passthrough = 0;
	}
    }
    elsif ($line =~ /^%\+/) {
	print "$line\n" if $passthrough;
    }
}

print "%%EndComments\n";

$EOD="*EOD*eps2form*";
$characters = "abcdefghijklmnopqrstuvwzyzABCDEFGHIJKLMNOPQRSTUVWZYZ0123456789";
for ($i = 0; $i < 8; ++$i) {
    $EOD .= substr($characters, int(rand(62)), 1);
}
$EOD .= '*';

print "/myimagedata currentfile << /Filter /SubFileDecode /DecodeParms << /EODCount 0 /EODString ($EOD) >> >> /ReusableStreamDecode filter\n";

print "%%BeginDocument: $ARGV[0]\n";

seek IN, 0, 0;

while (read(IN, $buf, 8192)) {
    print "$buf";
}

print "%%EndDocument\n";
print "$EOD\n";
print "def\n";
print "/myform << /FormType 1 /BBox [$bbox] /Matrix [ 1 0 0 1 0 0]\n";
print "/PaintProc { pop /ostate save def\n";
print "/showpage {} def /setpagedevice /pop load def\n";
print "myimagedata 0 setfileposition myimagedata cvx exec\n";
print "ostate restore } bind >> def\n";

exit 0;
